;nyquist plug-in
;version 4
;type process
;name "De-Esser"
;action "Reducing sibilance..."
;author "Felipe Porciuncula Zanabria"
;copyright "Released under terms of the GNU General Public License version 2"

;; Based on popmute.ny by Steve Daulton, (Sept 2011).
;; de-sser.ny by Felipe Porciuncula Zanabria. Mar 2018
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html .

;control apply "Listen" choice "Procesed sound,Removed parts" 0
;control type "Filter type" choice "High-stop,Band-stop" 0
;control hz "Frequencies above" int "Hz" 2200 1500 8000
;control thresh "Threshold" int "dB" -10 -24 0
;control floor "Mute Level" int "dB" -6 -100 0
;control look "Look ahead" int "milliseconds" 50 10 100
;control release "Release time" int "milliseconds" 250 20 500

;; scale input values
(setf hz (min hz (/ *sound-srate* 2)))
(setf floor (db-to-linear floor))
(setf thresh (db-to-linear thresh))
(setf look (/ look 1000.0))
(setf release (/ release 1000.0))
(setf attack look)

(defun inverse-gate (sig)
  (let* ((s-abs (s-abs sig))
         (env (gate s-abs look attack release floor thresh))
         (env (diff env (1+ floor)))
         (env (s-min (mult -1 floor) env))
         (env (clip env 1))
         (env (mult -1 env)))
    (mult sig env)))

(defun filter (sig)
  (case type
    (0 (highpass2 *track* hz))
    (1 (bandpass2 *track* hz 0.7071))))

(let* ((filtered (filter *track*))
       (passband (diff *track* filtered))
       (gated (multichan-expand #'inverse-gate filtered))
       (processed (sum passband gated)))
  (if (= apply 1)
      (diff *track* processed)
      processed))
